SCREEN 12
LINE (0, 0)-(640, 15), 1, BF
LINE (0, 460)-(640, 480), 1, BF
LOCATE 3, 32: COLOR 14: PRINT "JULIA GALLERY"
LOCATE 6, 26: PRINT "Author - Maxim Kakitsev"
LOCATE 7, 30: PRINT "maksim@freeuk.com"
LOCATE 8, 35: PRINT "(c)2001"
PRINT : COLOR 15
PRINT "This program draws Julia fractal based on a complex number"
PRINT "which consists of 2 parts: a (real part) and b (imaginary part)."
LOCATE 28, 1: PRINT "Press any key to continue"
WHILE INKEY$ = "": WEND
CLS
WINDOW (-2, -1.5)-(2, 1.5)
P = 15       'this is the complexity of a fractal.
             'the more the value the longer it will take to draw the picture.
DIM X1(P), Y1(P), X2(P), Y2(P)
again: COLOR 15
PRINT "Some examples of combinations for 'a' and 'b' are: a = -0.75  b = 0"
PRINT "                                                   a =  0.11  b = 0.66"
PRINT "                                                   a =  0     b = 1"
PRINT "                                                   a = -0.5   b = 0.55"
PRINT "                                                   a = -1     b = 0.25"
INPUT "choose real part A (between -1.5 and 1.5)", a
INPUT "choose imaginary part B (between -1.5 and 1.5)", b

CLS : LOCATE 2, 1: PRINT " A    B"
LOCATE 3, 1: PRINT a; " "; b
A1 = (.25 - a) / 2: B1 = -b / 2: R1 = SQR(A1 ^ 2 + B1 ^ 2)
X1(0) = .5 + SQR(R1 + A1): Y1(0) = SQR(R1 - A1)
IF b > 0 THEN Y1(0) = -Y1(0)
S = 1: GOSUB 3
FOR m = 1 TO 2 ^ (P - 1) - 1: S = P: N = m
DO WHILE N MOD 2 = 0
N = N / 2: S = S - 1
LOOP
GOSUB 2
wd = m / 10000
fx = -2.01 + wd
LINE (-2, 1.5)-(-.3617, 1.43), 14, B
LINE (-1.99, 1.49)-(fx, 1.44), 9, BF
NEXT m
LOCATE 28, 1: INPUT "to change A and B press 'Y'", ag$
IF UCASE$(ag$) = "Y" THEN GOTO again
END

2 X1(S - 1) = X2(S - 1): Y1(S - 1) = Y2(S - 1)
3 FOR J = S TO P
X = X1(J - 1): Y = Y1(J - 1)
R = SQR((X - a) ^ 2 + (Y - b) ^ 2) / 2: T = (X - a) / 2
X1(J) = SQR(R + T): X2(J) = -X1(J)
Y1(J) = SQR(R - T): IF Y < b THEN Y1(J) = -Y1(J)
Y2(J) = -Y1(J)
PSET (X1(J), Y2(J)): PSET (X2(J), Y1(J))
NEXT J: RETURN


